import { computed as h, openBlock as l, createElementBlock as s, normalizeClass as C, createElementVNode as r, toDisplayString as u, createCommentVNode as c, renderSlot as v, ref as V, createVNode as M, withCtx as $, useSlots as O, unref as q, resolveComponent as D, Fragment as x, renderList as B, createBlock as k, createTextVNode as A, inject as I, withDirectives as z, vModelDynamic as K, provide as U, watch as H, resolveDynamicComponent as F, normalizeStyle as Y, vModelCheckbox as P, onMounted as E, withKeys as R, withModifiers as N, vModelSelect as ee } from "vue";
import te from "fuse.js";
import { getProperty as j } from "dot-prop";
import { RouterLink as Z, useRoute as le } from "vue-router";
const se = { key: 0 }, oe = { class: "cf-action-card__body" }, ne = { class: "cf-action-card__action" }, zl = {
  __name: "ActionCard",
  props: {
    title: String,
    simple: Boolean
  },
  setup(o) {
    const t = o, e = h(() => ({
      "cf-action-card": !0,
      "cf-action-card--simple": t.simple
    }));
    return (n, a) => (l(), s("div", {
      class: C(e.value)
    }, [
      r("div", null, [
        t.title ? (l(), s("h5", se, u(t.title), 1)) : c("", !0),
        r("div", oe, [
          v(n.$slots, "body")
        ])
      ]),
      r("div", ne, [
        v(n.$slots, "action")
      ])
    ], 2));
  }
};
const G = (o, t) => {
  const e = o.__vccOpts || o;
  for (const [n, a] of t)
    e[n] = a;
  return e;
}, ae = {}, re = { class: "cf-app-bar" };
function ie(o, t) {
  return l(), s("header", re, [
    r("div", null, [
      v(o.$slots, "left")
    ]),
    r("div", null, [
      v(o.$slots, "right")
    ])
  ]);
}
const ue = /* @__PURE__ */ G(ae, [["render", ie]]);
const de = { class: "cf-dropdown-body" }, ce = {
  __name: "Dropdown",
  setup(o) {
    const t = V(!1), e = h(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": t.value
    }));
    return (n, a) => (l(), s("div", {
      class: C(e.value)
    }, [
      r("div", {
        class: "cf-dropdown-toggle",
        onClick: a[0] || (a[0] = (i) => t.value = !t.value)
      }, [
        v(n.$slots, "toggle")
      ]),
      r("div", de, [
        v(n.$slots, "body")
      ]),
      r("div", {
        class: "cf-dropdown-backdrop",
        onClick: a[1] || (a[1] = (i) => t.value = !1)
      })
    ], 2));
  }
};
const _e = {
  key: 0,
  class: "cf-app-bar-link"
}, pe = { class: "cf-app-bar-link__label" }, fe = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ r("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), ve = {
  key: 1,
  class: "cf-app-bar-link"
}, me = { class: "cf-app-bar-link__label" }, Fl = {
  __name: "AppBarLink",
  props: {
    dropdown: Boolean
  },
  setup(o) {
    return (t, e) => o.dropdown ? (l(), s("div", _e, [
      M(ce, null, {
        toggle: $(() => [
          r("div", pe, [
            v(t.$slots, "default"),
            fe
          ])
        ]),
        body: $(() => [
          v(t.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (l(), s("button", ve, [
      r("div", me, [
        v(t.$slots, "default")
      ])
    ]));
  }
};
const Ol = {
  __name: "AppView",
  props: { wide: Boolean },
  setup(o) {
    const t = o, e = h(() => ({
      "cf-app-view": !0,
      "cf-app-view--wide": t.wide
    }));
    return (n, a) => (l(), s("div", {
      class: C(e.value)
    }, [
      v(n.$slots, "default")
    ], 2));
  }
};
const be = { class: "cf-app-view-header" }, he = { key: 0 }, ye = { key: 1 }, ge = { key: 2 }, $e = {
  key: 3,
  class: "cf-app-view-header-actions"
}, Rl = {
  __name: "AppViewHeader",
  props: {
    surtitle: String,
    title: String,
    description: String
  },
  setup(o) {
    const t = o, e = O();
    return (n, a) => (l(), s("header", be, [
      t.surtitle ? (l(), s("p", he, u(t.surtitle), 1)) : c("", !0),
      t.title ? (l(), s("h1", ye, u(t.title), 1)) : c("", !0),
      t.description ? (l(), s("p", ge, u(t.description), 1)) : c("", !0),
      q(e).actions ? (l(), s("div", $e, [
        v(n.$slots, "actions")
      ])) : c("", !0)
    ]));
  }
};
const jl = {
  __name: "Banner",
  props: {
    type: String
  },
  setup(o) {
    const t = o, e = h(() => ({
      "cf-banner": !0,
      [`cf-banner--${t.type}`]: t.type
    }));
    return (n, a) => (l(), s("div", {
      class: C(e.value)
    }, [
      v(n.$slots, "default")
    ], 2));
  }
};
const ke = { class: "cf-breadcrumbs" }, Se = { key: 0 }, Il = {
  __name: "Breadcrumbs",
  props: { data: Array },
  setup(o) {
    const t = o;
    return (e, n) => {
      const a = D("RouterLink");
      return l(), s("ol", ke, [
        (l(!0), s(x, null, B(t.data, (i) => (l(), s("li", {
          key: i.name
        }, [
          i.path ? (l(), k(a, {
            key: 1,
            to: i.path
          }, {
            default: $(() => [
              A(u(i.name), 1)
            ]),
            _: 2
          }, 1032, ["to"])) : (l(), s("span", Se, u(i.name), 1))
        ]))), 128))
      ]);
    };
  }
}, W = {
  to: {
    type: [String, Object],
    default: null
  },
  type: {
    type: String,
    default: "button"
  },
  large: Boolean,
  wide: Boolean,
  color: {
    type: String,
    default: null
  },
  loading: Boolean,
  disabled: Boolean
};
const we = ["type", "disabled"], Ul = {
  __name: "FilledButton",
  props: W,
  setup(o) {
    const t = o, e = h(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-filled-button": !0,
      [`cf-filled-button--${t.color}`]: t.color
    }));
    return (n, a) => {
      const i = D("router-link");
      return n.to ? (l(), k(i, {
        key: 0,
        class: C(e.value),
        to: n.to,
        inert: t.disabled
      }, {
        default: $(() => [
          v(n.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), s("button", {
        key: 1,
        class: C(e.value),
        type: t.type,
        disabled: t.disabled
      }, [
        v(n.$slots, "default")
      ], 10, we));
    };
  }
};
const xe = ["type", "disabled"], Ce = {
  __name: "OutlinedButton",
  props: W,
  setup(o) {
    const t = o, e = h(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-outlined-button": !0,
      [`cf-outlined-button--${t.color}`]: t.color
    }));
    return (n, a) => {
      const i = D("router-link");
      return n.to ? (l(), k(i, {
        key: 0,
        class: C(e.value),
        to: n.to,
        inert: t.disabled
      }, {
        default: $(() => [
          v(n.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), s("button", {
        key: 1,
        class: C(e.value),
        type: t.type,
        disabled: t.disabled
      }, [
        v(n.$slots, "default")
      ], 10, xe));
    };
  }
};
const Ve = ["disabled"], Hl = {
  __name: "TextButton",
  props: {
    to: String,
    disabled: Boolean
  },
  setup(o) {
    const t = o;
    return (e, n) => {
      const a = D("router-link");
      return o.to ? (l(), k(a, {
        key: 0,
        class: "cf-text-button",
        to: o.to,
        inert: t.disabled
      }, {
        default: $(() => [
          v(e.$slots, "default")
        ]),
        _: 3
      }, 8, ["to", "inert"])) : (l(), s("button", {
        key: 1,
        class: "cf-text-button",
        type: "button",
        disabled: t.disabled
      }, [
        v(e.$slots, "default")
      ], 8, Ve));
    };
  }
};
const Be = { class: "cf-choice" }, Ae = ["type", "id", "name", "value", "true-value", "false-value", "required", "disabled"], Le = ["for"], Te = { key: 1 }, qe = {
  __name: "Choice",
  props: {
    modelValue: [Number, String, Boolean, Object, Array],
    value: [Number, String, Boolean, Object],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    type: String,
    label: [String, Boolean],
    helper: String,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = Math.random(), a = {
      name: I("choice-list-name", null),
      required: I("choice-list-required", null)
    }, i = h({
      get() {
        return e.modelValue;
      },
      set(d) {
        t("update:modelValue", d);
      }
    });
    return (d, f) => (l(), s("div", Be, [
      z(r("input", {
        "onUpdate:modelValue": f[0] || (f[0] = (b) => i.value = b),
        type: e.type,
        id: q(n),
        name: a.name,
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        required: a.required,
        disabled: e.disabled
      }, null, 8, Ae), [
        [K, i.value]
      ]),
      o.label ? (l(), s("label", {
        key: 0,
        for: q(n)
      }, u(e.label || e.value), 9, Le)) : c("", !0),
      e.helper ? (l(), s("small", Te, u(e.helper), 1)) : c("", !0)
    ]));
  }
};
const De = {
  key: 0,
  class: "cf-choice-list__label"
}, Kl = {
  __name: "ChoiceList",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    choices: Array,
    multiple: Boolean,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = h(() => ({
      "cf-choice-list": !0,
      "cf-choice-list--disabled": e.disabled
    })), a = h({
      get() {
        return e.modelValue;
      },
      set(i) {
        t("update:modelValue", i);
      }
    });
    return U("choice-list-name", Math.random()), U("choice-list-required", e.required), (i, d) => (l(), s("div", {
      class: C(n.value)
    }, [
      e.label ? (l(), s("div", De, u(e.label), 1)) : c("", !0),
      (l(!0), s(x, null, B(o.choices, (f) => (l(), k(qe, {
        key: f.value || f,
        type: e.multiple ? "checkbox" : "radio",
        label: f.label || f.value || f,
        helper: f.helper,
        value: f.value || f,
        disabled: e.disabled,
        modelValue: a.value,
        "onUpdate:modelValue": d[0] || (d[0] = (b) => a.value = b)
      }, null, 8, ["type", "label", "helper", "value", "disabled", "modelValue"]))), 128)),
      v(i.$slots, "default")
    ], 2));
  }
};
function T(o) {
  return typeof o == "function" ? o() : q(o);
}
function Ne(o, t, e) {
  const n = () => {
    var d, f;
    return new te(
      (d = T(t)) != null ? d : [],
      (f = T(e)) == null ? void 0 : f.fuseOptions
    );
  }, a = V(n());
  H(
    () => {
      var d;
      return (d = T(e)) == null ? void 0 : d.fuseOptions;
    },
    () => {
      a.value = n();
    },
    { deep: !0 }
  ), H(
    () => T(t),
    (d) => {
      a.value.setCollection(d);
    },
    { deep: !0 }
  );
  const i = h(() => {
    const d = T(e);
    if (d != null && d.matchAllWhenSearchEmpty && !T(o))
      return T(t).map((b, w) => ({ item: b, refIndex: w }));
    const f = d == null ? void 0 : d.resultLimit;
    return a.value.search(T(o), f ? { limit: f } : void 0);
  });
  return {
    fuse: a,
    results: i
  };
}
const X = {
  modelValue: [Number, String, Object],
  value: [Number, String, Object],
  label: String,
  disabled: Boolean,
  required: Boolean,
  helper: String,
  title: String,
  autofocus: Boolean
};
const Me = { class: "cf-form-control" }, ze = { key: 0 }, Fe = { class: "cf-form-control-widget" }, Oe = { key: 0 }, Re = ["disabled", "required", "type", "placeholder", "list", "step", "max", "min", "maxlength", "minlength", "pattern", "title", "autofocus"], je = { key: 1 }, Ie = { key: 1 }, J = {
  __name: "Input",
  props: {
    type: {
      type: String,
      default: "text"
    },
    placeholder: String,
    prefix: String,
    suffix: String,
    list: String,
    step: [Number, String],
    max: [Number, String],
    min: [Number, String],
    maxlength: [Number, String],
    minlength: [Number, String],
    pattern: String,
    ...X
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = V(!1), a = h(() => e.type.toLowerCase() === "password" ? n.value ? "text" : "password" : e.type), i = h({
      get: () => e.modelValue || e.value,
      set: (d) => t("update:modelValue", d)
    });
    return (d, f) => (l(), s("div", Me, [
      e.label ? (l(), s("label", ze, [
        A(u(e.label) + " ", 1),
        e.type.toLowerCase() === "password" ? (l(), s("button", {
          key: 0,
          type: "button",
          tabindex: "-1",
          onClick: f[0] || (f[0] = (b) => n.value = !n.value)
        }, u(n.value ? "Hide" : "Show"), 1)) : c("", !0)
      ])) : c("", !0),
      r("div", Fe, [
        e.prefix ? (l(), s("div", Oe, u(e.prefix), 1)) : c("", !0),
        z(r("input", {
          "onUpdate:modelValue": f[1] || (f[1] = (b) => i.value = b),
          disabled: e.disabled,
          required: e.required,
          type: a.value,
          placeholder: e.placeholder,
          list: e.list,
          step: e.step,
          max: e.max,
          min: e.min,
          maxlength: e.maxlength,
          minlength: e.minlength,
          pattern: e.pattern,
          title: e.title,
          autofocus: e.autofocus
        }, null, 8, Re), [
          [K, i.value]
        ]),
        e.suffix ? (l(), s("div", je, u(e.suffix), 1)) : c("", !0)
      ]),
      e.helper ? (l(), s("small", Ie, u(e.helper), 1)) : c("", !0)
    ]));
  }
};
const Ue = {
  key: 0,
  class: "cf-data-table-title"
}, He = {
  key: 1,
  class: "cf-data-table-description"
}, Ke = {
  key: 2,
  class: "cf-data-table-search"
}, Pe = {
  key: 3,
  class: "cf-data-table-action"
}, Ee = {
  __name: "DataTableHeader",
  props: {
    title: String,
    description: String,
    searchable: Boolean,
    search: String
  },
  emits: ["update:search"],
  setup(o, { emit: t }) {
    const e = o, n = O(), a = h({
      get: () => e.search,
      set: (i) => t("update:search", i)
    });
    return (i, d) => (l(), s("header", null, [
      e.title ? (l(), s("div", Ue, u(e.title), 1)) : c("", !0),
      e.description ? (l(), s("div", He, u(e.description), 1)) : c("", !0),
      e.searchable ? (l(), s("div", Ke, [
        M(J, {
          modelValue: a.value,
          "onUpdate:modelValue": d[0] || (d[0] = (f) => a.value = f),
          label: "Search"
        }, null, 8, ["modelValue"])
      ])) : c("", !0),
      q(n).default ? (l(), s("div", Pe, [
        v(i.$slots, "default")
      ])) : c("", !0)
    ]));
  }
}, Ze = {
  key: 0,
  "data-table-checkbox": ""
}, Ge = ["value", "checked", "disabled"], We = {
  key: 1,
  "data-table-row-actions": ""
}, Xe = { key: 0 }, Je = {
  __name: "DataTableRow",
  props: {
    data: Object,
    columns: Array,
    forceMenu: Boolean,
    includeCheckbox: Boolean
  },
  emits: ["toggle", "action"],
  setup(o, { emit: t }) {
    const e = o, n = h(() => e.data._), a = h(() => e.data.data), i = h(() => e.forceMenu || n.value.actions.length > 1), d = h(() => n.value.actions.map((b) => {
      const w = b.name || b, p = b.key || w.toUpperCase().replaceAll(" ", "_"), _ = () => t("action", { key: p, data: a.value });
      let S = "span";
      return b.to && (S = Z), b.href && (S = "a"), {
        label: w,
        to: b.to,
        href: b.href,
        key: p,
        invoke: _,
        component: S
      };
    })), f = h(() => {
      const b = {
        component: "span",
        label: "•••",
        invoke: null
      };
      return i.value ? b : d.value[0];
    });
    return (b, w) => (l(), s("tr", null, [
      e.includeCheckbox ? (l(), s("td", Ze, [
        r("input", {
          type: "checkbox",
          value: a.value.id,
          checked: n.value.isSelected,
          disabled: !n.value.isSelectable,
          onChange: w[0] || (w[0] = (p) => t("toggle"))
        }, null, 40, Ge)
      ])) : c("", !0),
      v(b.$slots, "default", {}, () => [
        (l(!0), s(x, null, B(e.columns, (p) => {
          var _;
          return l(), s("td", {
            key: p.key
          }, u((_ = q(j)(a.value, p.key)) == null ? void 0 : _.toLocaleString()), 1);
        }), 128))
      ]),
      n.value.actions ? (l(), s("td", We, [
        r("button", null, [
          (l(), k(F(f.value.component), {
            to: f.value.to,
            href: f.value.href,
            onClick: f.value.invoke
          }, {
            default: $(() => [
              A(u(f.value.label), 1)
            ]),
            _: 1
          }, 8, ["to", "href", "onClick"]))
        ]),
        i.value ? (l(), s("div", Xe, [
          (l(!0), s(x, null, B(d.value, (p) => (l(), s("button", {
            key: p.key
          }, [
            (l(), k(F(p.component), {
              to: p.to,
              href: p.href,
              onClick: p.invoke
            }, {
              default: $(() => [
                A(u(p.label), 1)
              ]),
              _: 2
            }, 1032, ["to", "href", "onClick"]))
          ]))), 128))
        ])) : c("", !0)
      ])) : c("", !0)
    ]));
  }
};
const Qe = { class: "cf-data-table" }, Ye = {
  key: 0,
  style: { "--w": "3rem" }
}, et = {
  key: 1,
  style: { "--w": "4rem" }
}, tt = {
  key: 0,
  "data-table-checkbox": ""
}, lt = ["disabled"], st = ["onClick"], ot = { key: 1 }, nt = { key: 1 }, Pl = {
  __name: "DataTable",
  props: {
    title: String,
    description: String,
    data: {
      type: Array,
      default: () => []
    },
    columns: {
      type: Array,
      default: () => []
    },
    selection: {
      type: Array,
      default: []
    },
    rowActions: [Boolean, Array],
    forceRowMenu: Boolean,
    customTemplate: Boolean,
    selectable: Boolean,
    sortable: Boolean,
    defaultSortKey: {
      type: String,
      default: ""
    },
    searchable: Boolean
  },
  emits: ["update:selection", "row-action"],
  setup(o, { emit: t }) {
    const e = o, n = O(), a = V(e.defaultSortKey), i = V("asc"), d = V(""), f = h(() => {
      if (e.searchable) {
        const { results: m } = Ne(d, e.data, {
          fuseOptions: {
            keys: e.columns.map(({ key: g }) => g),
            minMatchCharLength: 2,
            threshold: 0.15
          },
          matchAllWhenSearchEmpty: !0
        });
        return m.value;
      } else
        return e.data;
    }), b = h(() => f.value.map((m) => m.item || m).sort((m, g) => {
      const y = j(m, a.value), L = j(g, a.value);
      return typeof y == "string" ? i.value === "asc" ? y == null ? void 0 : y.localeCompare(L) : L == null ? void 0 : L.localeCompare(y) : i.value === "asc" ? y - L : L - y;
    }).map(({ _: m, ...g }) => ({
      _: {
        isDisabled: (m == null ? void 0 : m.disabled) ?? !1,
        isSelectable: (m == null ? void 0 : m.seletable) ?? !0,
        isSelected: e.selection.includes(g.id),
        actions: (m == null ? void 0 : m.actions) ?? e.rowActions
      },
      data: g
    }))), w = h(() => b.value.some((m) => m._.isSelectable)), p = h({
      get: () => {
        const m = b.value.filter((g) => g._.isSelectable).length;
        return m >= 1 && m === e.selection.length;
      },
      set: (m) => {
        let g = [];
        m === !0 && (g = b.value.filter((y) => !y._.isDisabled && y._.isSelectable).map((y) => y.data.id)), t("update:selection", g);
      }
    }), _ = (m) => {
      const g = e.selection.includes(m) ? e.selection.slice().filter((y) => m !== y) : e.selection.concat(m);
      t("update:selection", g);
    }, S = (m) => {
      a.value === m ? i.value = i.value === "asc" ? "desc" : "asc" : (a.value = m, i.value = "asc");
    };
    return (m, g) => (l(), s("div", Qe, [
      e.title || e.description || e.searchable || q(n).header ? (l(), k(Ee, {
        key: 0,
        search: d.value,
        "onUpdate:search": g[0] || (g[0] = (y) => d.value = y),
        title: e.title,
        description: e.description,
        searchable: e.searchable
      }, {
        default: $(() => [
          v(m.$slots, "header")
        ]),
        _: 3
      }, 8, ["search", "title", "description", "searchable"])) : c("", !0),
      r("table", null, [
        r("colgroup", null, [
          e.selectable ? (l(), s("col", Ye)) : c("", !0),
          (l(!0), s(x, null, B(e.columns, (y) => (l(), s("col", {
            key: y.key,
            style: Y({ "--w": y.width })
          }, null, 4))), 128)),
          e.rowActions ? (l(), s("col", et)) : c("", !0)
        ]),
        r("thead", null, [
          r("tr", null, [
            e.selectable ? (l(), s("th", tt, [
              z(r("input", {
                "onUpdate:modelValue": g[1] || (g[1] = (y) => p.value = y),
                type: "checkbox",
                disabled: !w.value
              }, null, 8, lt), [
                [P, p.value]
              ])
            ])) : c("", !0),
            (l(!0), s(x, null, B(e.columns, (y) => (l(), s("th", {
              key: y.key
            }, [
              e.sortable ? (l(), s("button", {
                key: 0,
                onClick: (L) => S(y.key)
              }, u(y.label), 9, st)) : (l(), s("div", ot, u(y.label), 1))
            ]))), 128)),
            e.rowActions ? (l(), s("th", nt)) : c("", !0)
          ])
        ]),
        r("tbody", null, [
          (l(!0), s(x, null, B(b.value, (y) => (l(), k(Je, {
            key: y.data.id,
            data: y,
            columns: e.columns,
            "include-checkbox": e.selectable,
            "force-menu": e.forceRowMenu,
            onToggle: (L) => _(y.data.id),
            onAction: g[2] || (g[2] = (L) => t("row-action", L))
          }, {
            default: $(() => [
              v(m.$slots, "row", {
                data: y.data
              })
            ]),
            _: 2
          }, 1032, ["data", "columns", "include-checkbox", "force-menu", "onToggle"]))), 128))
        ])
      ])
    ]));
  }
};
const at = { class: "cf-sidebar-nav" }, rt = /* @__PURE__ */ r("hr", null, null, -1), it = /* @__PURE__ */ r("span", { class: "material-symbols-outlined" }, null, -1), ut = /* @__PURE__ */ r("span", null, null, -1), dt = [
  it,
  ut
], ct = {
  __name: "Sidebar",
  setup(o) {
    const t = V(!1), e = h(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": t.value
    }));
    return (n, a) => (l(), s("aside", {
      class: C(e.value)
    }, [
      r("div", null, [
        r("nav", at, [
          v(n.$slots, "default"),
          rt
        ]),
        r("button", {
          class: "cf-sidebar-toggle",
          onClick: a[0] || (a[0] = (i) => t.value = !t.value)
        }, dt)
      ])
    ], 2));
  }
};
const El = {
  __name: "AppLayout",
  setup(o) {
    return E(() => {
      document.body.dataset.layout = "app";
    }), (t, e) => (l(), s(x, null, [
      M(ue, null, {
        left: $(() => [
          v(t.$slots, "brand")
        ]),
        right: $(() => [
          v(t.$slots, "navigation")
        ]),
        _: 3
      }),
      M(ct, null, {
        default: $(() => [
          v(t.$slots, "sidebar")
        ]),
        _: 3
      }),
      r("main", null, [
        v(t.$slots, "main")
      ])
    ], 64));
  }
};
const _t = ["onKeydown"], pt = { class: "cf-dialog-header" }, ft = { class: "cf-dialog__title" }, vt = { key: 0 }, mt = { class: "cf-dialog-body" }, bt = { class: "cf-dialog-footer" }, ht = ["disabled"], yt = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ r("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), gt = [
  yt
], Zl = {
  __name: "Dialog",
  props: {
    title: String,
    description: String,
    persist: {
      type: Boolean,
      default: !1
    },
    persistent: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["close"],
  setup(o, { emit: t }) {
    const e = o, n = V(), a = () => {
      !e.persist && !e.persistent && t("close");
    };
    return E(() => n.value.showModal()), (i, d) => (l(), s("dialog", {
      class: "cf-dialog",
      ref_key: "dialog",
      ref: n,
      onKeydown: R(N(a, ["prevent"]), ["esc"])
    }, [
      r("div", pt, [
        r("div", ft, u(e.title), 1),
        e.description ? (l(), s("div", vt, u(e.description), 1)) : c("", !0)
      ]),
      r("div", mt, [
        v(i.$slots, "body")
      ]),
      r("div", bt, [
        v(i.$slots, "footer")
      ]),
      e.persistent ? c("", !0) : (l(), s("button", {
        key: 0,
        class: "cf-dialog-close",
        disabled: e.persist,
        onClick: a
      }, gt, 8, ht))
    ], 40, _t));
  }
};
const $t = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, kt = { class: "material-symbols-outlined" }, St = { class: "cf-dropdown-item__label" }, wt = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, xt = { class: "material-symbols-outlined" }, Ct = { class: "cf-dropdown-item__label" }, Gl = {
  __name: "DropdownItem",
  props: {
    icon: String,
    to: [Object, String],
    large: Boolean
  },
  setup(o) {
    const t = o, e = h(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": t.large
    }));
    return (n, a) => {
      const i = D("router-link");
      return o.to ? (l(), k(i, {
        key: 1,
        class: C(e.value),
        to: o.to
      }, {
        default: $(() => [
          o.icon ? (l(), s("div", wt, [
            r("span", xt, u(o.icon), 1)
          ])) : c("", !0),
          r("div", Ct, [
            v(n.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["class", "to"])) : (l(), s("button", {
        key: 0,
        class: C(e.value)
      }, [
        o.icon ? (l(), s("div", $t, [
          r("span", kt, u(o.icon), 1)
        ])) : c("", !0),
        r("div", St, [
          v(n.$slots, "default")
        ])
      ], 2));
    };
  }
};
const Vt = { class: "cf-drop-zone" }, Bt = ["onDrop"], At = { class: "cf-drop-zone-box__label" }, Lt = { class: "cf-drop-zone-box__action" }, Tt = /* @__PURE__ */ r("span", null, "select from device", -1), qt = ["required"], Dt = {
  key: 0,
  class: "cf-drop-zone-box__helper"
}, Nt = {
  key: 1,
  class: "cf-drop-zone-list"
}, Mt = /* @__PURE__ */ r("div", { class: "cf-drop-zone-list__header" }, null, -1), zt = { class: "cf-drop-zone-list__item" }, Ft = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "12",
  height: "12"
}, [
  /* @__PURE__ */ r("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Ot = [
  Ft
], Wl = {
  __name: "DropZone",
  props: {
    modelValue: File,
    label: {
      type: String,
      default: "Add your file here."
    },
    max: {
      type: [Number, String],
      default: 0
    },
    accept: String,
    required: Boolean
  },
  emits: ["update:modelValue", "add", "cancel"],
  setup(o, { emit: t }) {
    const e = o, n = V(null), a = h(() => !!(e.required && !e.modelValue)), i = h(() => {
      if (e.modelValue) {
        const _ = (e.modelValue.size / 1048576).toFixed(0), S = (_ / 1e3).toFixed(1);
        return _ < 100 ? `${_} MB` : `${S} GB`;
      } else
        return "0 MB";
    }), d = (p) => {
      const _ = p.target.files[0];
      b(_);
    }, f = (p) => {
      const _ = p.dataTransfer.files[0];
      b(_);
    }, b = (p) => {
      const _ = parseInt(e.max) * 1048576;
      _ && _ < p.size ? (n.value.value = "", alert(`File cannot exceed ${e.max} MB`)) : (t("update:modelValue", p), t("add", p));
    }, w = () => {
      t("update:modelValue", null), t("cancel");
    };
    return (p, _) => (l(), s("div", Vt, [
      o.modelValue ? (l(), s("div", Nt, [
        Mt,
        r("div", zt, [
          r("div", null, u(e.modelValue.name), 1),
          r("div", null, u(i.value), 1),
          r("button", { onClick: w }, Ot)
        ])
      ])) : (l(), s("div", {
        key: 0,
        class: "cf-drop-zone-box",
        onDrop: N(f, ["prevent"]),
        onDragenter: _[0] || (_[0] = N(() => {
        }, ["prevent"])),
        onDragover: _[1] || (_[1] = N(() => {
        }, ["prevent"])),
        onDragleave: _[2] || (_[2] = N(() => {
        }, ["prevent"]))
      }, [
        r("div", At, u(e.label), 1),
        r("label", Lt, [
          A(" Drag and drop or "),
          Tt,
          r("input", {
            type: "file",
            ref_key: "input",
            ref: n,
            required: a.value,
            onChange: d
          }, null, 40, qt)
        ]),
        e.max ? (l(), s("div", Dt, " Files larger than " + u(e.max) + " MB cannot be uploaded ", 1)) : c("", !0)
      ], 40, Bt))
    ]));
  }
};
const Rt = { class: "cf-tag" }, jt = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ r("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), It = [
  jt
], Q = {
  __name: "Tag",
  props: {
    removable: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["remove"],
  setup(o, { emit: t }) {
    const e = o;
    return (n, a) => (l(), s("div", Rt, [
      r("span", null, [
        v(n.$slots, "default")
      ]),
      e.removable ? (l(), s("button", {
        key: 0,
        onClick: a[0] || (a[0] = (i) => t("remove"))
      }, It)) : c("", !0)
    ]));
  }
};
const Ut = { class: "cf-file-picker" }, Ht = {
  key: 0,
  class: "cf-file-picker-label"
}, Kt = {
  key: 1,
  class: "cf-button cf-file-picker-button"
}, Pt = ["required"], Xl = {
  __name: "FilePicker",
  props: {
    modelValue: File,
    label: String,
    action: {
      type: String,
      default: "Choose file"
    },
    required: Boolean
  },
  emits: ["update:modelValue", "change"],
  setup(o, { emit: t }) {
    const e = o, n = (i) => {
      t("update:modelValue", i.target.files[0]), t("change", i);
    }, a = () => {
      t("update:modelValue", null);
    };
    return (i, d) => (l(), s("div", Ut, [
      e.label ? (l(), s("div", Ht, u(e.label), 1)) : c("", !0),
      e.modelValue ? (l(), k(Q, {
        key: 2,
        onRemove: a
      }, {
        default: $(() => {
          var f;
          return [
            A(u((f = e.modelValue) == null ? void 0 : f.name), 1)
          ];
        }),
        _: 1
      })) : (l(), s("label", Kt, [
        A(u(e.action) + " ", 1),
        r("input", {
          type: "file",
          onChange: n,
          required: o.required
        }, null, 40, Pt)
      ]))
    ]));
  }
};
const Et = { class: "cf-header" }, Zt = { key: 0 }, Gt = { key: 1 }, Wt = { key: 0 }, Jl = {
  __name: "Header",
  props: {
    size: {
      type: String,
      default: "h4"
    },
    title: String,
    surtitle: String,
    subtitle: String
  },
  setup(o) {
    const t = o, e = O();
    return (n, a) => (l(), s("div", Et, [
      r("div", null, [
        t.surtitle ? (l(), s("p", Zt, u(t.surtitle), 1)) : c("", !0),
        (l(), k(F(t.size), null, {
          default: $(() => [
            A(u(t.title), 1)
          ]),
          _: 1
        })),
        t.subtitle ? (l(), s("p", Gt, u(t.subtitle), 1)) : c("", !0)
      ]),
      q(e).action ? (l(), s("div", Wt, [
        v(n.$slots, "action")
      ])) : c("", !0)
    ]));
  }
};
const Xt = ["value", "max"], Ql = {
  __name: "Progress",
  props: {
    value: {
      type: [Number, String],
      default: 0
    },
    max: {
      type: [Number, String],
      default: 100
    }
  },
  setup(o) {
    const t = o;
    return (e, n) => (l(), s("progress", {
      class: "cf-progress",
      value: t.value,
      max: t.max
    }, u(o.value) + "% ", 9, Xt));
  }
};
const Jt = { class: "cf-form-control" }, Qt = { key: 0 }, Yt = { class: "cf-form-control-widget" }, el = { key: 0 }, tl = ["disabled", "required", "title", "autofocus"], ll = {
  key: 0,
  value: null
}, sl = ["value", "disabled"], ol = { key: 1 }, nl = { key: 1 }, al = {
  __name: "Select",
  props: {
    options: Array,
    ...X
  },
  emits: ["update:modelValue", "input"],
  setup(o, { emit: t }) {
    const e = o, n = h({
      get: () => e.modelValue || e.value,
      set: (a) => {
        t("update:modelValue", a), t("input", { data: a });
      }
    });
    return (a, i) => (l(), s("div", Jt, [
      e.label ? (l(), s("label", Qt, u(e.label), 1)) : c("", !0),
      r("div", Yt, [
        e.prefix ? (l(), s("div", el, u(e.prefix), 1)) : c("", !0),
        z(r("select", {
          "onUpdate:modelValue": i[0] || (i[0] = (d) => n.value = d),
          disabled: e.disabled,
          required: e.required,
          title: e.title,
          autofocus: e.autofocus
        }, [
          !e.required && e.options.length ? (l(), s("option", ll)) : c("", !0),
          (l(!0), s(x, null, B(e.options, (d) => (l(), s("option", {
            key: d.value || d,
            value: d.value || d,
            disabled: d.disabled ?? !1
          }, u(d.label || d), 9, sl))), 128)),
          v(a.$slots, "default")
        ], 8, tl), [
          [ee, n.value]
        ]),
        e.suffix ? (l(), s("div", ol, u(e.suffix), 1)) : c("", !0)
      ]),
      e.helper ? (l(), s("small", nl, u(e.helper), 1)) : c("", !0)
    ]));
  }
};
const rl = { key: 0 }, il = { key: 0 }, ul = { class: "material-symbols-outlined" }, dl = { class: "cf-sidebar-link" }, cl = { class: "material-symbols-outlined" }, _l = { class: "cf-sidebar-link-children" }, Yl = {
  __name: "SidebarLink",
  props: {
    to: [String, Object],
    href: String,
    icon: String,
    parent: String
  },
  setup(o) {
    const t = o, e = h(() => t.parent ? le().path.includes(t.parent) : null), n = h(() => t.to ? Z : "a");
    return (a, i) => t.parent ? (l(), s("div", {
      key: 1,
      class: C(["cf-sidebar-link-group", { hasRouterLinkActive: e.value }])
    }, [
      r("button", dl, [
        r("figure", null, [
          r("span", cl, u(t.icon), 1)
        ]),
        r("span", null, [
          v(a.$slots, "default")
        ])
      ]),
      r("div", _l, [
        v(a.$slots, "children")
      ])
    ], 2)) : (l(), s("button", rl, [
      (l(), k(F(n.value), {
        class: "cf-sidebar-link",
        to: t.to,
        href: t.href
      }, {
        default: $(() => [
          t.icon ? (l(), s("figure", il, [
            r("span", ul, u(t.icon), 1)
          ])) : c("", !0),
          r("span", null, [
            v(a.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["to", "href"]))
    ]));
  }
};
const pl = {}, fl = { class: "cf-spinner" }, vl = /* @__PURE__ */ r("div", null, null, -1), ml = /* @__PURE__ */ r("div", null, null, -1), bl = /* @__PURE__ */ r("div", null, null, -1), hl = /* @__PURE__ */ r("div", null, null, -1), yl = [
  vl,
  ml,
  bl,
  hl
];
function gl(o, t) {
  return l(), s("div", fl, yl);
}
const es = /* @__PURE__ */ G(pl, [["render", gl]]);
const $l = { class: "cf-summary-list" }, ts = {
  __name: "SummaryList",
  props: {
    data: {
      type: Array,
      default: () => []
    }
  },
  setup(o) {
    const t = o;
    return (e, n) => (l(), s("dl", $l, [
      (l(!0), s(x, null, B(t.data, (a) => (l(), s(x, null, [
        r("dt", null, u(a.label), 1),
        r("dd", null, u(a.value), 1)
      ], 64))), 256))
    ]));
  }
};
const kl = { class: "cf-switch" }, Sl = ["value", "true-value", "false-value", "disabled"], wl = {
  key: 0,
  class: "cf-switch__label"
}, ls = {
  __name: "Switch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = h({
      get() {
        return e.modelValue;
      },
      set(a) {
        t("update:modelValue", a);
      }
    });
    return (a, i) => (l(), s("div", kl, [
      z(r("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": i[0] || (i[0] = (d) => n.value = d),
        type: "checkbox",
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, Sl), [
        [P, n.value]
      ]),
      e.label ? (l(), s("div", wl, u(e.label), 1)) : c("", !0)
    ]));
  }
};
const xl = { class: "cf-navigation-tabs" }, ss = {
  __name: "TabNavigation",
  props: {
    tabs: Array
  },
  setup(o) {
    const t = o;
    return (e, n) => {
      const a = D("router-link");
      return l(), s("nav", xl, [
        r("ul", null, [
          (l(!0), s(x, null, B(t.tabs, (i, d) => (l(), s("li", { key: d }, [
            M(a, {
              to: i.to
            }, {
              default: $(() => [
                A(u(i.label), 1)
              ]),
              _: 2
            }, 1032, ["to"])
          ]))), 128))
        ])
      ]);
    };
  }
};
const Cl = ["inert"], Vl = { key: 0 }, Bl = { class: "cf-tags-field__input" }, Al = ["required"], Ll = { class: "cf-tags-field__tags" }, Tl = { key: 1 }, os = {
  __name: "TagsField",
  props: {
    modelValue: Array,
    label: String,
    buttonText: {
      type: String,
      default: "Add"
    },
    prefix: String,
    options: Array,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = V(!1), a = V(""), i = h(() => {
      var p;
      return (p = e.options) == null ? void 0 : p.map((_) => ({
        label: _.label || _,
        value: _.value || _
      }));
    }), d = h(() => {
      var p;
      return (p = i.value) == null ? void 0 : p.filter(
        (_) => !e.modelValue.includes(_.value)
      );
    }), f = (p) => i.value.find((_) => _.value === p).label, b = () => {
      if (!a.value || e.disabled)
        return !1;
      const p = e.modelValue;
      p.push(a.value), t("update:modelValue", p), a.value = "", n.value = !1;
    }, w = (p) => {
      if (e.disabled)
        return !1;
      const _ = e.modelValue;
      _.splice(p, 1), t("update:modelValue", _);
    };
    return (p, _) => (l(), s("div", {
      class: "cf-tags-field",
      inert: e.disabled
    }, [
      e.label ? (l(), s("label", Vl, u(e.label), 1)) : c("", !0),
      r("div", Bl, [
        !e.options && n.value ? (l(), k(J, {
          key: 0,
          modelValue: a.value,
          "onUpdate:modelValue": _[0] || (_[0] = (S) => a.value = S),
          prefix: e.prefix,
          onKeydown: R(b, ["enter"]),
          onChange: b,
          required: ""
        }, null, 8, ["modelValue", "prefix", "onKeydown"])) : c("", !0),
        e.options && n.value ? (l(), k(al, {
          key: 1,
          modelValue: a.value,
          "onUpdate:modelValue": _[1] || (_[1] = (S) => a.value = S),
          options: d.value,
          onKeydown: R(b, ["enter"]),
          onChange: b,
          required: ""
        }, null, 8, ["modelValue", "options", "onKeydown"])) : c("", !0),
        n.value ? c("", !0) : (l(), k(Ce, {
          key: 2,
          color: "blue",
          onClick: _[2] || (_[2] = (S) => n.value = !0)
        }, {
          default: $(() => [
            A(u(e.buttonText), 1)
          ]),
          _: 1
        })),
        r("input", {
          class: "cf-tags-field__input__faux",
          type: "text",
          required: e.required && !e.modelValue.length
        }, null, 8, Al)
      ]),
      r("div", Ll, [
        (l(!0), s(x, null, B(e.modelValue, (S, m) => (l(), k(Q, {
          key: S,
          onRemove: (g) => w(m)
        }, {
          default: $(() => [
            A(u(e.prefix) + " " + u(e.options ? f(S) : S), 1)
          ]),
          _: 2
        }, 1032, ["onRemove"]))), 128))
      ]),
      e.helper ? (l(), s("small", Tl, u(e.helper), 1)) : c("", !0)
    ], 8, Cl));
  }
};
export {
  zl as CfActionCard,
  ue as CfAppBar,
  Fl as CfAppBarLink,
  El as CfAppLayout,
  Ol as CfAppView,
  Rl as CfAppViewHeader,
  jl as CfBanner,
  Il as CfBreadcrumbs,
  qe as CfChoice,
  Kl as CfChoiceList,
  Pl as CfDataTable,
  Zl as CfDialog,
  Wl as CfDropZone,
  ce as CfDropdown,
  Gl as CfDropdownItem,
  Xl as CfFilePicker,
  Ul as CfFilledButton,
  Jl as CfHeader,
  J as CfInput,
  Ce as CfOutlinedButton,
  Ql as CfProgress,
  al as CfSelect,
  ct as CfSidebar,
  Yl as CfSidebarLink,
  es as CfSpinner,
  ts as CfSummaryList,
  ls as CfSwitch,
  ss as CfTabNavigation,
  Q as CfTag,
  os as CfTagsField,
  Hl as CfTextButton
};
